/**
 * Copyright 2018 Jay Liu
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.jay.base.util.sqlUtil;

import java.sql.SQLException;
import java.util.List;
import java.util.Map;

import org.springframework.jdbc.core.simple.SimpleJdbcCall;

import com.jay.base.database.jdbc.JdbcTemplateEx;
import com.jay.base.database.jdbc.SimpleJdbcInsertEx;
import com.jay.base.model.BaseStoreProcedure;
import com.jay.base.model.BaseTable;
import com.jay.base.model.QueryType;


/**
 * allow user to query by sql command and return with result models
 * @author Jay Liu(JayTs.Liu@gmail.com)
 * @since 2018
 * @update 20180712
 * @version 1.5
 */
public interface SqlUtil {
	
	/**
	 * query with single row return 
	 * @param sql - user sql statement
	 * @param clazz - container of user define class model 
	 * @param params - sql input parameters
	 * @return class model with data values
	 * @throws Exception EmptyResultDataAccessException: (Ex. Incorrect result size: expected 1 ...)
	 */
	public <E> E queryForObject(String sql, Class<? extends E> clazz, Object... params);
	
	/**
	 * query return with map
	 * @param sql - query statement
	 * @param params - input parameters
	 * @return
	 */
	public <E> Map<String, Object> queryForMap(String sql, Object... params);
	
	/**
	 * query return with list of map
	 * @param sql - query statement
	 * @param params - input parameters
	 * @return
	 */
	public <E> List<Map<String, Object>> queryForList(String sql, Object... params);
	
	/**
	 * query with single row return 
	 * @param sql - user sql statement
	 * @param clazz - container of user define class model 
	 * @param params - sql input parameters
	 * @return class model with data values
	 * @throws Exception 
	 */
	public <E> E findOne(String sql, Class<? extends E> clazz, Object... params);
	
	/**
	 * query with multiple returns
	 * @param sql - user sql statement
	 * @param clazz - container of user define class model 
	 * @param params - sql input parameters
	 * @return - list class model with data values
	 * @throws SQLException 
	 */
	public <E> List<E> find(String sql, Class<E> clazz, Object... params);
	
	/**
	 * query to execute
	 * @param sql - user sql statement
	 * @param params - sql input parameters
	 * @return number of row changes
	 */
	public int update(String sql, Object... params);
	
	/**
	 * insert new row from user define model
	 * @param o - object of user define class model
	 * @return number of row changes
	 * @throws Exception 
	 */
	public int insert(BaseTable o);
	
	/**
	 * update by id
	 * @param o - object of user define class model
	 * @return number of row changes
	 */
	public int update(BaseTable o);
	
	/**
	 * delete record by id
	 * @param o - object of user define class model
	 * @return number of row changes
	 */
	public int delete(BaseTable o);
	
	/**
	 * submits a batch of commands to the database for execution 
	 * @param sqlList - list of SQL statement
	 * @return int[] - an array of update counts containing one element for each command in the batch
	 */
	public int[] updateBatch(List<String> sqlList);
	
	
	/**
	 * no longer supported method will do nothing and only return false
	 * submits a batch of commands to the database for execution 
	 * @param sql - SQL statement
	 * @param paramsLst list input parameters for each command
	 * @return boolean - result success
	 */
	@Deprecated
	public boolean updateBatch(String sql, List<Object[]> paramsLst);
	
	/**
	 * batchUpdate by custom model list
	 * @param queryType enum - query type (INSERT, UPDATE, DELETE)
	 * @param objectList - list of custom model with execute value
	 * @return int array of success result
	 */
	public int[] updateBatch(QueryType queryType, List<?> objectList);
	
	public void init(JdbcTemplateEx jdbcTemplateEx);
	
	/**
	 * to initial required 
	 * @param jdbcTemplateEx
	 * @param simpleJdbcInsertEx 
	 * @param simpleJdbcInsertEx
	 */
	public void init(JdbcTemplateEx jdbcTemplateEx, SimpleJdbcInsertEx simpleJdbcInsertEx);
	
	public void init(JdbcTemplateEx jdbcTemplateEx, SimpleJdbcInsertEx simpleJdbcInsertEx, SimpleJdbcCall simpleJdbcCall);//20181224 add
	
	/**
	 * insert a data row and retrieve with generate key
	 * @param object - user defined model with data to insert
	 * @return return increment number generated by database 
	 */
	public Number insertAndReturnKey(BaseTable object);
	
	/**
	 * to execute stored procedure 
	 * @param baseStoreProcedure model of stored procedure
	 * @param clazz return container object
	 * @return 
	 */
	public <E> E executeSp(BaseStoreProcedure storeProcedure, Class<E> clazz);//20181224 add
	public <E> List<E> executeSpRetrieveList(BaseStoreProcedure storeProcedure, Class<E> clazz);//20181224 add
	public Map<String, Object> executeSpRetrieveMap(BaseStoreProcedure storeProcedure);

	/**
	 * insert data with out defined exclude annotation
	 * @param object - user defined model with data to insert
	 * @return Integer - success row count
	 */
	public int insertFilterExclude(BaseTable object);

	public JdbcTemplateEx getJdbcTemplate();

	public SimpleJdbcInsertEx getSimpleJdbcInsert();
	
	public SimpleJdbcCall getSimpleJdbcCall();//20181224 add

	public void setJdbcTemplate(JdbcTemplateEx jdbcTemplateEx);//20190321 add

	public void setSimpleJdbcInsert(SimpleJdbcInsertEx simpleJdbcInsertEx);

	public void setSimpleJdbcCall(SimpleJdbcCall simpleJdbcCall);

}
